/*
Copyright (C) 2011 Craciun Dan <craciun.dan@tuxarena.com>

This file is part of NeonView.

NeonView is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 2 of the License, or
(at your option) any later version.

NeonView is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with NeonView.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "header.h"

void put_settings (TM *tm) {
	GtkWidget *vbox;

	tm->win_set = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_window_set_default_size(GTK_WINDOW(tm->win_set), 640, 400);
	gtk_widget_set_size_request(tm->win_set, 640, 400);
	gtk_window_set_resizable(GTK_WINDOW(tm->win_set), FALSE);
	gtk_window_set_position(GTK_WINDOW(tm->win_set), GTK_WIN_POS_CENTER);
	gtk_container_set_border_width(GTK_CONTAINER(tm->win_set), 10);
	gtk_window_set_title(GTK_WINDOW(tm->win_set), "NeonView Settings");

	vbox = gtk_vbox_new(FALSE, 10);
	gtk_container_add(GTK_CONTAINER(tm->win_set), vbox);

	GtkWidget *notebook;
	GtkWidget *vbox1;
	GtkWidget *label1;

	GtkAccelGroup *accel_group;
	accel_group = gtk_accel_group_new();
	gtk_window_add_accel_group(GTK_WINDOW(tm->win_set), accel_group);

	notebook = gtk_notebook_new();
	gtk_notebook_set_tab_pos(GTK_NOTEBOOK(notebook), GTK_POS_TOP);

	GtkWidget *hbox_help;
	hbox_help = gtk_hbox_new(FALSE, 0);
	gtk_box_pack_start(GTK_BOX(hbox_help), notebook, FALSE, FALSE, 0);

	tm->label_help = gtk_label_new("This is the NeonView configuration window. Mouse-over each option will provide a description for it in this area.");
	gtk_label_set_line_wrap(GTK_LABEL(tm->label_help), TRUE);
	gtk_widget_set_size_request(tm->label_help, 300, 100);
	gtk_box_pack_start(GTK_BOX(hbox_help), tm->label_help, FALSE, FALSE, 10);

	gtk_box_pack_start(GTK_BOX(vbox), hbox_help, TRUE, TRUE, 0);

	gtk_widget_set_size_request(notebook, 320, 340);

	//	gtk_box_pack_start(GTK_BOX(vbox), notebook, TRUE, TRUE, 0);

	vbox1 = gtk_vbox_new(FALSE, 0);
	label1 = gtk_label_new("General");
	gtk_notebook_append_page(GTK_NOTEBOOK(notebook), vbox1, label1);

	/*****/
	/*
	GtkWidget *vbox2, *vbox3, *vbox4, *label2, *label3, *label4;
	vbox2 = gtk_vbox_new(FALSE, 0);
	vbox3 = gtk_vbox_new(FALSE, 0);
	vbox4 = gtk_vbox_new(FALSE, 0);
	label2 = gtk_label_new("General2");
	label3 = gtk_label_new("General3");
	label4 = gtk_label_new("General4");
	gtk_notebook_append_page(GTK_NOTEBOOK(notebook), vbox2, label2);
	gtk_notebook_append_page(GTK_NOTEBOOK(notebook), vbox3, label3);
	gtk_notebook_append_page(GTK_NOTEBOOK(notebook), vbox4, label4);
	*/
	/*****/

	GtkWidget *fixed;

	fixed = gtk_fixed_new();
	gtk_box_pack_start(GTK_BOX(vbox1), fixed, FALSE, FALSE, 0);

	GtkWidget *label11, *label12;
	int top = 0;

	GtkWidget *ebox11, *ebox12;

	label11 = gtk_label_new("Main Window");
	gtk_label_set_markup(GTK_LABEL(label11), "<b>Main Window</b>");
	gtk_fixed_put(GTK_FIXED(fixed), label11, 10, top = top + 10);

	ebox11 = gtk_event_box_new();
	tm->check11 = gtk_check_button_new_with_label("Start maximized");
	if (strcmp(tm->tcfg->maximized, "yes") == 0) {
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(tm->check11), TRUE);
		tm->tcfg->active11 = 1;
	} else {
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(tm->check11), FALSE);
		tm->tcfg->active11 = 0;
	}
	gtk_container_add(GTK_CONTAINER(ebox11), tm->check11);
	gtk_fixed_put(GTK_FIXED(fixed), ebox11, 10 + 10, top = top + 24);

	ebox12 = gtk_event_box_new();
	tm->check12 = gtk_check_button_new_with_label("Remember window size");
	if (strcmp(tm->tcfg->remember_win_size, "yes") == 0) {
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(tm->check12), TRUE);
		tm->tcfg->active12 = 1;
	} else {
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(tm->check12), FALSE);
		tm->tcfg->active12 = 0;
	}
	gtk_container_add(GTK_CONTAINER(ebox12), tm->check12);
	gtk_fixed_put(GTK_FIXED(fixed), ebox12, 10 + 10, top = top + 24);

	GtkWidget *ebox13, *ebox14;

	label12 = gtk_label_new("Images");
	gtk_label_set_markup(GTK_LABEL(label12), "<b>Images</b>");
	gtk_fixed_put(GTK_FIXED(fixed), label12, 10, top = top + 40);

	ebox13 = gtk_event_box_new();
	tm->check13 = gtk_check_button_new_with_label("Lock fit to window");
	if (strcmp(tm->tcfg->fit_next, "yes") == 0) {
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(tm->check13), TRUE);
		tm->tcfg->active13 = 1;
	} else {
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(tm->check13), FALSE);
		tm->tcfg->active13 = 0;
	}
	gtk_container_add(GTK_CONTAINER(ebox13), tm->check13);
	gtk_fixed_put(GTK_FIXED(fixed), ebox13, 10 + 10, top = top + 24);

	ebox14 = gtk_event_box_new();
	tm->check14 = gtk_check_button_new_with_label("Remember fit to window");
	if (strcmp(tm->tcfg->remember_fit, "yes") == 0) {
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(tm->check14), TRUE);
		tm->tcfg->active14 = 1;
	} else {
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(tm->check14), FALSE);
		tm->tcfg->active14 = 0;
	}
	gtk_container_add(GTK_CONTAINER(ebox14), tm->check14);
	gtk_fixed_put(GTK_FIXED(fixed), ebox14, 10 + 10, top = top + 24);

	/*
	if (strcmp(tm->tcfg->maximized, "yes") == 0) {
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(tm->check11), TRUE);
	} else {
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(tm->check11), FALSE);
	}
	if (strcmp(tm->tcfg->remember_win_size, "yes") == 0) {
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(tm->check12), TRUE);
	} else {
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(tm->check12), FALSE);
	}
	*/

	g_signal_connect_swapped(ebox11, "enter-notify-event", G_CALLBACK(show_help_11), tm);
	g_signal_connect_swapped(ebox11, "leave-notify-event", G_CALLBACK(show_help_label), tm);
	g_signal_connect_swapped(ebox12, "enter-notify-event", G_CALLBACK(show_help_12), tm);
	g_signal_connect_swapped(ebox12, "leave-notify-event", G_CALLBACK(show_help_label), tm);
	g_signal_connect_swapped(ebox13, "enter-notify-event", G_CALLBACK(show_help_13), tm);
	g_signal_connect_swapped(ebox13, "leave-notify-event", G_CALLBACK(show_help_label), tm);
	g_signal_connect_swapped(ebox14, "enter-notify-event", G_CALLBACK(show_help_14), tm);
	g_signal_connect_swapped(ebox14, "leave-notify-event", G_CALLBACK(show_help_label), tm);

	g_signal_connect_swapped(tm->check11, "clicked", G_CALLBACK(clicked_check11), tm);
	g_signal_connect_swapped(tm->check12, "clicked", G_CALLBACK(clicked_check12), tm);
	g_signal_connect_swapped(tm->check13, "clicked", G_CALLBACK(clicked_check13), tm);
	g_signal_connect_swapped(tm->check14, "clicked", G_CALLBACK(clicked_check14), tm);

	GtkWidget *hbox;
	GtkWidget *button_ok, *button_no;
	GtkWidget *lalign, *ralign;

	lalign = gtk_alignment_new(0, 1, 0, 0);
	ralign = gtk_alignment_new(1, 1, 0, 0);

	button_no = gtk_button_new_with_label("Cancel");
	button_ok = gtk_button_new_with_label("OK");
	gtk_widget_set_size_request(button_no, 80, 30);
	gtk_widget_set_size_request(button_ok, 80, 30);

	gtk_container_add(GTK_CONTAINER(lalign), button_no);
	gtk_container_add(GTK_CONTAINER(ralign), button_ok);

	hbox = gtk_hbox_new(FALSE, 0);

	gtk_container_add(GTK_CONTAINER(hbox), lalign);
	gtk_container_add(GTK_CONTAINER(hbox), ralign);

	//	gtk_box_pack_start(GTK_BOX(hbox), lalign, FALSE, FALSE, 0);
	//	gtk_box_pack_start(GTK_BOX(hbox), ralign, FALSE, FALSE, 0);

	gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, FALSE, 0);

	g_signal_connect_swapped(button_ok, "clicked", G_CALLBACK(clicked_ok), tm);
	g_signal_connect_swapped(button_no, "clicked", G_CALLBACK(gtk_widget_destroy), tm->win_set);

	gtk_widget_add_accelerator(button_no, "activate", accel_group, GDK_KEY_Escape, 0, GTK_ACCEL_VISIBLE);

	gtk_widget_show_all(vbox);
	gtk_widget_show(tm->win_set);
}

void show_help_11 (TM *tm) {
	gtk_label_set_markup(GTK_LABEL(tm->label_help), "Check this if you want NeonView to start with the main window maximized.\n\nThis option takes effect the next time you start NeonView and will override the <b>Remember window size</b> option.");
}

void show_help_12 (TM *tm) {
	gtk_label_set_markup(GTK_LABEL(tm->label_help), "Check this if you want NeonView to remember the size of the main window between sessions.\n\nNotice that if <b>Start maximized</b> is checked, NeonView will still save the window size, but it will start maximized by default.\n\nIf this option is checked and the window is maximized when you close NeonView, the next time it will start the size will be maximized.");
}

void show_help_13 (TM *tm) {
	gtk_label_set_markup(GTK_LABEL(tm->label_help), "If this is checked, once you press the <b>Fit to Window</b> button, all the images in that directory accessible via the <b>Next</b> or <b>Previous</b> buttons will be displayed resized to fit the window.\n\nIf this option is unchecked, the next or previous images will be displayed at normal size.");
}

void show_help_14 (TM *tm) {
	gtk_label_set_markup(GTK_LABEL(tm->label_help), "If checked, the next time it will start NeonView will remember if it should start with images displayed to fit to window rather than display them at normal size.\n\nThis could be useful for example if you usually have very large images and you want to see them scaled to the window size by default.");
}

void show_help_label (TM *tm) {
	gtk_label_set_text(GTK_LABEL(tm->label_help), "This is the NeonView configuration window. Mouse-over each option will provide a description for it in this area.");
}

void clicked_check11 (TM *tm) {
	if (tm->tcfg->active11 == 0) {
		tm->tcfg->active11 = 1;
	} else if (tm->tcfg->active11 == 1) {
		tm->tcfg->active11 = 0;
	}
}

void clicked_check12 (TM *tm) {
	if (tm->tcfg->active12 == 0) {
		tm->tcfg->active12 = 1;
	} else if (tm->tcfg->active12 == 1) {
		tm->tcfg->active12 = 0;
	}
}

void clicked_check13 (TM *tm) {
	if (tm->tcfg->active13 == 0) {
		tm->tcfg->active13 = 1;
	} else {
		tm->tcfg->active13 = 0;
	}
}

void clicked_check14 (TM *tm) {
	if (tm->tcfg->active14 == 0) {
		tm->tcfg->active14 = 1;
	} else {
		tm->tcfg->active14 = 0;
	}
}

void clicked_ok (TM *tm) {
	if (tm->tcfg->active11 == 0) {
		strcpy(tm->tcfg->maximized, "no");
	} else {
		strcpy(tm->tcfg->maximized, "yes");
	}

	if (tm->tcfg->active12 == 0) {
		strcpy(tm->tcfg->remember_win_size, "no");
	} else {
		strcpy(tm->tcfg->remember_win_size, "yes");
	}

	if (tm->tcfg->active13 == 0) {
		strcpy(tm->tcfg->fit_next, "no");
	} else {
		strcpy(tm->tcfg->fit_next, "yes");
	}

	if (tm->tcfg->active14 == 0) {
		strcpy(tm->tcfg->remember_fit, "no");
	} else {
		strcpy(tm->tcfg->remember_fit, "yes");
	}

	gtk_widget_destroy(tm->win_set);
}

void clicked_no (TM *tm) {
}
